#include <string.h>
#include "include/dart_api.h"
#include "include/dart_native_api.h"
#include "dartify.h"
#include "dartified.c"


void dw__void(Dart_NativeArguments arguments) {
  Dart_EnterScope();
  Dart_Handle error;
  _void();
  
  Dart_ExitScope();
}

void dw__String(Dart_NativeArguments arguments) {
  Dart_EnterScope();
  Dart_Handle error;
  const char * result =  _String();
  Dartify_SetStringReturnValue(arguments, result);
  Dart_ExitScope();
}

void dw__int(Dart_NativeArguments arguments) {
  Dart_EnterScope();
  Dart_Handle error;
  error = Dartify_GetIntNativeArgument(arguments, 0);
  Dartify_HandleError(error);
  int a = dartifyResult.i;
  error = Dartify_GetIntNativeArgument(arguments, 1);
  Dartify_HandleError(error);
  int b = dartifyResult.i;
  int result =  _int(a, b);
  Dart_SetIntegerReturnValue(arguments, result);
  Dart_ExitScope();
}

void dw__uint(Dart_NativeArguments arguments) {
  Dart_EnterScope();
  Dart_Handle error;
  uint result =  _uint();
  Dart_SetIntegerReturnValue(arguments, result);
  Dart_ExitScope();
}

void dw__float(Dart_NativeArguments arguments) {
  Dart_EnterScope();
  Dart_Handle error;
  float result =  _float();
  Dart_SetDoubleReturnValue(arguments, result);
  Dart_ExitScope();
}

void dw__double(Dart_NativeArguments arguments) {
  Dart_EnterScope();
  Dart_Handle error;
  double result =  _double();
  Dart_SetDoubleReturnValue(arguments, result);
  Dart_ExitScope();
}

void dw__boolf(Dart_NativeArguments arguments) {
  Dart_EnterScope();
  Dart_Handle error;
  bool result =  _boolf();
  Dart_SetBooleanReturnValue(arguments, result);
  Dart_ExitScope();
}

void dw__boolt(Dart_NativeArguments arguments) {
  Dart_EnterScope();
  Dart_Handle error;
  bool result =  _boolt();
  Dart_SetBooleanReturnValue(arguments, result);
  Dart_ExitScope();
}

void dw__speak(Dart_NativeArguments arguments) {
  Dart_EnterScope();
  Dart_Handle error;
  error = Dartify_GetNativeStringArgument(arguments, 0);
  Dartify_HandleError(error);
  const char * msg = dartifyResult.str;
  _speak(msg);
  
  Dart_ExitScope();
}

void dw__mpzadd(Dart_NativeArguments arguments) {
  Dart_EnterScope();

  Dart_Handle error;
  mpz_t ret;
  mpz_init(ret);
  mpz_init(dartifyResult.mpz);
  error = Dartify_GetMpzNativeArgument(arguments, 0);
  Dartify_HandleError(error);
  mpz_t a;
  mpz_init_set(a,dartifyResult.mpz);
  error = Dartify_GetMpzNativeArgument(arguments, 1);
  Dartify_HandleError(error);
  mpz_t b;
  mpz_init_set(b,dartifyResult.mpz);
  _mpzadd(ret, a, b);
  Dartify_SetIntegerReturnValueFromMpz(arguments, ret);
  mpz_clear(ret);
  mpz_clear(dartifyResult.mpz);
  Dart_ExitScope();
}

void dw__mpz(Dart_NativeArguments arguments) {
  Dart_EnterScope();

  Dart_Handle error;
  mpz_t ret;
  mpz_init(ret);
  mpz_init(dartifyResult.mpz);
  _mpz(ret);
  Dartify_SetIntegerReturnValueFromMpz(arguments, ret);
  mpz_clear(ret);
  mpz_clear(dartifyResult.mpz);
  Dart_ExitScope();
}

Dartify_ResolveName(
  if (!strcmp("_void", cname)) return dw__void;
  if (!strcmp("_String", cname)) return dw__String;
  if (!strcmp("_int", cname)) return dw__int;
  if (!strcmp("_uint", cname)) return dw__uint;
  if (!strcmp("_float", cname)) return dw__float;
  if (!strcmp("_double", cname)) return dw__double;
  if (!strcmp("_boolf", cname)) return dw__boolf;
  if (!strcmp("_boolt", cname)) return dw__boolt;
  if (!strcmp("_mpzadd", cname)) return dw__mpzadd;
  if (!strcmp("_mpz", cname)) return dw__mpz;
  if (!strcmp("_speak", cname)) return dw__speak;
)

Dartify_InitializeExtension(dartified_extension_Init)
