#include <string.h>
#include "include/dart_api.h"
#include "include/dart_native_api.h"
#include "dartify.h"
#include "test.c"

void dw_bigmul (Dart_NativeArguments arguments) {
  Dart_EnterScope();
  Dart_Handle error;
  mpz_t product;
  mpz_init(product);
  mpz_init(dartifyResult.mpz);
  error = Dartify_GetMpzNativeArgument(arguments, 0);
  Dartify_HandleError(error);
  mpz_t a;
  mpz_init_set(a, dartifyResult.mpz);
  
  error = Dartify_GetMpzNativeArgument(arguments, 1);
  Dartify_HandleError(error);
  mpz_t b;
  mpz_init_set(b, dartifyResult.mpz);
  
  bigmul(product, a, b);
  Dartify_SetIntegerReturnValueFromMpz(arguments, product);
  
  mpz_clear(product);
  mpz_clear(dartifyResult.mpz);
  Dart_ExitScope();
}

Dartify_ResolveName(
  if (!strcmp("bigmul", cname)) return dw_bigmul;
)

Dartify_InitializeExtension(test_extension_Init)
